com.amazonaws.codegen.model.config.customization

## Class ConvenienceTypeOverload

- java.lang.Object
- - com.amazonaws.codegen.model.config.customization.ConvenienceTypeOverload

    public class ConvenienceTypeOverload
    extends Object

Customization to allow generation of additional setter overloads for a 'convenience' type (i.e. a different type then what the member actually is but a more convenient representation to work with, I.E. String rather than ByteBuffer). Customization is configured with an adapter that knows how to convert the 'convenience' type to the actual member type

Note - This customization is not directly exposed through `CustomizationConfig` at the moment. Instead several pre-canned customizations use this under the hood but expose limited functionality for overloading setters. This decision was made to discourage use of overloaded types and instead model the member in a more natural way to begin with. In the future we may either decide to fully expose this customization or just add more pre-canned settings as the need arises

Currently this does not support overloads for List or Map types but it could be easily implemented in the Generator.

### Constructor Summary

Constructors
Constructor and Description
`ConvenienceTypeOverload()`

### Method Summary

All Methods Instance Methods Concrete Methods
`boolean` `accepts(ShapeModel shape, MemberModel member)`
`String` `getConvenienceType()`
`String` `getMemberName()`
`String` `getShapeName()`
`String` `getTypeAdapterFqcn()`
`void` `setConvenienceType(String convenienceType)`
`void` `setMemberName(String memberName)`
`void` `setShapeName(String shapeName)`
`void` `setTypeAdapterFqcn(String typeAdapterFqcn)`
`ConvenienceTypeOverload` `withConvenienceType(String convenienceType)`
`ConvenienceTypeOverload` `withMemberName(String memberName)`
`ConvenienceTypeOverload` `withShapeName(String shapeName)`
`ConvenienceTypeOverload` `withTypeAdapterFqcn(String typeAdapterFqcn)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### ConvenienceTypeOverload

    public ConvenienceTypeOverload()

### Method Detail

#### getShapeName

    public String getShapeName()

#### setShapeName

    public void setShapeName(String shapeName)

#### withShapeName

    public ConvenienceTypeOverload withShapeName(String shapeName)

#### getMemberName

    public String getMemberName()

#### setMemberName

    public void setMemberName(String memberName)

#### withMemberName

    public ConvenienceTypeOverload withMemberName(String memberName)

#### getConvenienceType

    public String getConvenienceType()

#### setConvenienceType

    public void setConvenienceType(String convenienceType)

#### withConvenienceType

    public ConvenienceTypeOverload withConvenienceType(String convenienceType)

#### getTypeAdapterFqcn

    public String getTypeAdapterFqcn()

#### setTypeAdapterFqcn

    public void setTypeAdapterFqcn(String typeAdapterFqcn)

#### withTypeAdapterFqcn

    public ConvenienceTypeOverload withTypeAdapterFqcn(String typeAdapterFqcn)

#### accepts

    public boolean accepts(ShapeModel shape,
                           MemberModel member)

Parameters:
  `shape` - Current shape
  `member` - Current member
Returns:
  True if the `ConvenienceTypeOverload` applies. False otherwise